/*! 
	\file un.h
	\author GOIGOUX Lucie & JEUDI--LEMOINE Alix
	\date 22/12/22
	\brief Partie 1 de la SAE 1.02

	Application de gestion des candidature dans les IUT de France
*/

#define LEN_MAX 30

typedef struct MaillonDept {
  char departement[LEN_MAX];
  int nbP;
  char responsable[LEN_MAX];
  struct MaillonDept* suiv;
} MaillonDept;

typedef MaillonDept* ListeDept;

typedef struct {
  char ville[LEN_MAX];
  ListeDept ldept;
} VilleIUT;


void titreMenuPrincipal(void);
void menuCandidat(void);
void menuAdmin(void);
void menuResponsable(void);
void menuPrincipal(void);

VilleIUT* creerVille(void);
VilleIUT** ajouterVille(VilleIUT** tiut, VilleIUT* ville, int* nbVilles);
void afficherListeVilles(VilleIUT** tiut, int nbVilles);

ListeDept creerListeDepartement(void);
void afficherListeDepartement(VilleIUT ville);
MaillonDept* creerDepartement(char* departement, int nbP, char* responsable);
ListeDept ajouterDepartement(ListeDept ldept, MaillonDept* dept);
ListeDept supprimerDepartement(ListeDept ldept, char* searchDept);
void modifierNbPlaces(VilleIUT** tiut, int nbVilles, char* searchIUT, char* searchDept, int nb);

void saveVilles(VilleIUT* tiut[], int nbVilles);
VilleIUT** readVilles(int* nbVilles);

void test(void);